// inherit.cpp -- demonstrate inheritance

#include "inherit.hpp"

base operator+(base &b1, base &b2) {  // friend function

  cout << "friend operator+ called: ";
  cout << b1.str << " + " << b2.str << "\n";
  base temp("?3");
  return temp;
}

base& base::operator=(base &b) {

  cout << "base operator=(base &" << b.str << ") called\n";
  str = b.str;
  return *this;
}

derived::derived(derived &d) {

  str = d.str;
  cout << "derived(derived &" << str << ") called\n";
}

derived::derived(base &b) : base(b) {

  cout << "derived(base &" << b << ") : base("
				    << b << ") called\n";
}

derived& derived::operator=(derived &d) {

  cout << "derived operator=(derived &" << d.str << ") called\n";
  str = d.str;
  return *this;
}

derived& derived::operator=(base &b) {

  cout << "derived operator=(base &" << b << ") called\n";
  str = b.str;
  return *this;
}
